//+------------------------------------------------------------------+
//|                                                Jurik average.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_color3  PaleVioletRed
#property indicator_color4  LimeGreen
#property indicator_color5  LimeGreen
#property indicator_color6  Red
#property indicator_color7  Red
#property indicator_color8  Peru
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  2

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//    
//
//

extern string TimeFrame               = "current time frame";
extern int    Length                  = 26;
extern double Phase                   = 0;
extern int    Price                   = 0;
extern bool   ShowMiddleLine          = true;
extern int    DzLookBackBars          = 35;
extern double DzStartBuyProbability1  = 0.10;
extern double DzStartBuyProbability2  = 0.25;
extern double DzStartSellProbability1 = 0.10;
extern double DzStartSellProbability2 = 0.25;
extern bool   alertsOn                = false;
extern bool   alertsOnCurrent         = true;
extern bool   alertsOnBuy1CrossUp     = true;
extern bool   alertsOnBuy1CrossDown   = true;
extern bool   alertsOnBuy2CrossUp     = true;
extern bool   alertsOnBuy2CrossDown   = true;
extern bool   alertsOnMiddleCrossUp   = true;
extern bool   alertsOnMiddleCrossDown = true;
extern bool   alertsOnSell2CrossUp    = true;
extern bool   alertsOnSell2CrossDown  = true;
extern bool   alertsOnSell1CrossUp    = true;
extern bool   alertsOnSell1CrossDown  = true;
extern bool   alertsOnSlopeUp         = true;
extern bool   alertsOnSlopeDown       = true;
extern bool   alertsMessage           = true;
extern bool   alertsSound             = false;
extern bool   alertsEmail             = false;

extern bool   ShowArrows             = true;//false;
extern string ArrowsIdentifier       = "DZJurikArrows1";
extern double ArrowsGap              = 0.75;
extern color  ArrowUpColor           = LimeGreen;
extern int    ArrowUpWidth           = 2;
extern color  ArrowDownColor         = PaleVioletRed; 
extern int    ArrowDownWidth         = 2;
extern bool   ArrowOnBuy1CrossUp     = false;//true;
extern bool   ArrowOnBuy1CrossDown   = false;//true;
extern bool   ArrowOnBuy2CrossUp     = false;//true;
extern bool   ArrowOnBuy2CrossDown   = false;//true;
extern bool   ArrowOnMiddleCrossUp   = false;//true;
extern bool   ArrowOnMiddleCrossDown = false;//true;
extern bool   ArrowOnSell2CrossUp    = false;//true;
extern bool   ArrowOnSell2CrossDown  = false;//true;
extern bool   ArrowOnSell1CrossUp    = false;//true;
extern bool   ArrowOnSell1CrossDown  = false;//true;
extern bool   ArrowOnSlopeUp         = true;
extern bool   ArrowOnSlopeDown       = true;
extern bool   Interpolate            = true;

//
//
//
//
//

double average[];
double averageDa[];
double averageDb[];
double bl1Buffer[];
double bl2Buffer[];
double sl1Buffer[];
double sl2Buffer[];
double zliBuffer[];
double slope[];
double trends[][6];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,average);
   SetIndexBuffer(1,averageDa);
   SetIndexBuffer(2,averageDb);
   SetIndexBuffer(3,bl1Buffer);
   SetIndexBuffer(4,bl2Buffer);
   SetIndexBuffer(5,sl2Buffer);
   SetIndexBuffer(6,sl1Buffer);
   SetIndexBuffer(7,zliBuffer);
   SetIndexBuffer(8,slope);
   
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

   IndicatorShortName("Jurik filter simple ("+Length+")");
   return(0);
}
int deinit() 
{ 
   int lookForLength = StringLen(ArrowsIdentifier);
   for (int i=ObjectsTotal(); i>= 0; i--)
   {
      string name = ObjectName(i); if (StringSubstr(name,0,lookForLength) == ArrowsIdentifier) ObjectDelete(name);  
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double precision = Point*100.0;
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { average[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               if (slope[limit]==-1) CleanPoint(limit,averageDa,averageDb);
               for (i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);               
                     averageDa[i] = EMPTY_VALUE;
                     averageDb[i] = EMPTY_VALUE;
                     average[i] = iCustom(NULL,timeFrame,indicatorFileName,"",Length,Phase,Price,ShowMiddleLine,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,
                                  alertsOn,alertsOnCurrent,alertsOnBuy1CrossUp,alertsOnBuy1CrossDown,alertsOnBuy2CrossUp,alertsOnBuy2CrossDown,alertsOnMiddleCrossUp,alertsOnMiddleCrossDown,alertsOnSell2CrossUp,alertsOnSell2CrossDown,alertsOnSell1CrossUp,alertsOnSell1CrossDown,alertsOnSlopeUp,alertsOnSlopeDown,alertsMessage,alertsSound,alertsEmail,
                                  ShowArrows,ArrowsIdentifier,ArrowsGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,ArrowOnBuy1CrossUp,ArrowOnBuy1CrossDown,ArrowOnBuy2CrossUp,ArrowOnBuy2CrossDown,ArrowOnMiddleCrossUp,ArrowOnMiddleCrossDown,ArrowOnSell2CrossUp,ArrowOnSell2CrossDown,ArrowOnSell1CrossUp,ArrowOnSell1CrossDown,ArrowOnSlopeUp,ArrowOnSlopeDown,0,y);
                     bl1Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"",Length,Phase,Price,ShowMiddleLine,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,
                                  alertsOn,alertsOnCurrent,alertsOnBuy1CrossUp,alertsOnBuy1CrossDown,alertsOnBuy2CrossUp,alertsOnBuy2CrossDown,alertsOnMiddleCrossUp,alertsOnMiddleCrossDown,alertsOnSell2CrossUp,alertsOnSell2CrossDown,alertsOnSell1CrossUp,alertsOnSell1CrossDown,alertsOnSlopeUp,alertsOnSlopeDown,alertsMessage,alertsSound,alertsEmail,
                                  ShowArrows,ArrowsIdentifier,ArrowsGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,ArrowOnBuy1CrossUp,ArrowOnBuy1CrossDown,ArrowOnBuy2CrossUp,ArrowOnBuy2CrossDown,ArrowOnMiddleCrossUp,ArrowOnMiddleCrossDown,ArrowOnSell2CrossUp,ArrowOnSell2CrossDown,ArrowOnSell1CrossUp,ArrowOnSell1CrossDown,ArrowOnSlopeUp,ArrowOnSlopeDown,3,y);
                     bl2Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"",Length,Phase,Price,ShowMiddleLine,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,
                                  alertsOn,alertsOnCurrent,alertsOnBuy1CrossUp,alertsOnBuy1CrossDown,alertsOnBuy2CrossUp,alertsOnBuy2CrossDown,alertsOnMiddleCrossUp,alertsOnMiddleCrossDown,alertsOnSell2CrossUp,alertsOnSell2CrossDown,alertsOnSell1CrossUp,alertsOnSell1CrossDown,alertsOnSlopeUp,alertsOnSlopeDown,alertsMessage,alertsSound,alertsEmail,
                                  ShowArrows,ArrowsIdentifier,ArrowsGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,ArrowOnBuy1CrossUp,ArrowOnBuy1CrossDown,ArrowOnBuy2CrossUp,ArrowOnBuy2CrossDown,ArrowOnMiddleCrossUp,ArrowOnMiddleCrossDown,ArrowOnSell2CrossUp,ArrowOnSell2CrossDown,ArrowOnSell1CrossUp,ArrowOnSell1CrossDown,ArrowOnSlopeUp,ArrowOnSlopeDown,4,y);
                     sl2Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"",Length,Phase,Price,ShowMiddleLine,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,
                                  alertsOn,alertsOnCurrent,alertsOnBuy1CrossUp,alertsOnBuy1CrossDown,alertsOnBuy2CrossUp,alertsOnBuy2CrossDown,alertsOnMiddleCrossUp,alertsOnMiddleCrossDown,alertsOnSell2CrossUp,alertsOnSell2CrossDown,alertsOnSell1CrossUp,alertsOnSell1CrossDown,alertsOnSlopeUp,alertsOnSlopeDown,alertsMessage,alertsSound,alertsEmail,
                                  ShowArrows,ArrowsIdentifier,ArrowsGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,ArrowOnBuy1CrossUp,ArrowOnBuy1CrossDown,ArrowOnBuy2CrossUp,ArrowOnBuy2CrossDown,ArrowOnMiddleCrossUp,ArrowOnMiddleCrossDown,ArrowOnSell2CrossUp,ArrowOnSell2CrossDown,ArrowOnSell1CrossUp,ArrowOnSell1CrossDown,ArrowOnSlopeUp,ArrowOnSlopeDown,5,y);
                     sl1Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"",Length,Phase,Price,ShowMiddleLine,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,
                                  alertsOn,alertsOnCurrent,alertsOnBuy1CrossUp,alertsOnBuy1CrossDown,alertsOnBuy2CrossUp,alertsOnBuy2CrossDown,alertsOnMiddleCrossUp,alertsOnMiddleCrossDown,alertsOnSell2CrossUp,alertsOnSell2CrossDown,alertsOnSell1CrossUp,alertsOnSell1CrossDown,alertsOnSlopeUp,alertsOnSlopeDown,alertsMessage,alertsSound,alertsEmail,
                                  ShowArrows,ArrowsIdentifier,ArrowsGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,ArrowOnBuy1CrossUp,ArrowOnBuy1CrossDown,ArrowOnBuy2CrossUp,ArrowOnBuy2CrossDown,ArrowOnMiddleCrossUp,ArrowOnMiddleCrossDown,ArrowOnSell2CrossUp,ArrowOnSell2CrossDown,ArrowOnSell1CrossUp,ArrowOnSell1CrossDown,ArrowOnSlopeUp,ArrowOnSlopeDown,6,y);
                     zliBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"",Length,Phase,Price,ShowMiddleLine,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,
                                  alertsOn,alertsOnCurrent,alertsOnBuy1CrossUp,alertsOnBuy1CrossDown,alertsOnBuy2CrossUp,alertsOnBuy2CrossDown,alertsOnMiddleCrossUp,alertsOnMiddleCrossDown,alertsOnSell2CrossUp,alertsOnSell2CrossDown,alertsOnSell1CrossUp,alertsOnSell1CrossDown,alertsOnSlopeUp,alertsOnSlopeDown,alertsMessage,alertsSound,alertsEmail,
                                  ShowArrows,ArrowsIdentifier,ArrowsGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,ArrowOnBuy1CrossUp,ArrowOnBuy1CrossDown,ArrowOnBuy2CrossUp,ArrowOnBuy2CrossDown,ArrowOnMiddleCrossUp,ArrowOnMiddleCrossDown,ArrowOnSell2CrossUp,ArrowOnSell2CrossDown,ArrowOnSell1CrossUp,ArrowOnSell1CrossDown,ArrowOnSlopeUp,ArrowOnSlopeDown,7,y);
                     slope[i] =   iCustom(NULL,timeFrame,indicatorFileName,"",Length,Phase,Price,ShowMiddleLine,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,
                                  alertsOn,alertsOnCurrent,alertsOnBuy1CrossUp,alertsOnBuy1CrossDown,alertsOnBuy2CrossUp,alertsOnBuy2CrossDown,alertsOnMiddleCrossUp,alertsOnMiddleCrossDown,alertsOnSell2CrossUp,alertsOnSell2CrossDown,alertsOnSell1CrossUp,alertsOnSell1CrossDown,alertsOnSlopeUp,alertsOnSlopeDown,alertsMessage,alertsSound,alertsEmail,
                                  ShowArrows,ArrowsIdentifier,ArrowsGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,ArrowOnBuy1CrossUp,ArrowOnBuy1CrossDown,ArrowOnBuy2CrossUp,ArrowOnBuy2CrossDown,ArrowOnMiddleCrossUp,ArrowOnMiddleCrossDown,ArrowOnSell2CrossUp,ArrowOnSell2CrossDown,ArrowOnSell1CrossUp,ArrowOnSell1CrossDown,ArrowOnSlopeUp,ArrowOnSlopeDown,8,y);

                      if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                      //
                      //
                      //
                      //
                      //

                      datetime time = iTime(NULL,timeFrame,y);
                        for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                        for(int x = 1; x < n; x++)
                        {
                           average[i+x] = average[i] + (average[i+n] - average[i])* x/n;                             
                           bl1Buffer[i+x] = bl1Buffer[i] + (bl1Buffer[i+n] - bl1Buffer[i])* x/n;                             
                           bl2Buffer[i+x] = bl2Buffer[i] + (bl2Buffer[i+n] - bl2Buffer[i])* x/n;                             
                           sl2Buffer[i+x] = sl2Buffer[i] + (sl2Buffer[i+n] - sl2Buffer[i])* x/n;                             
                           sl2Buffer[i+x] = sl2Buffer[i] + (sl2Buffer[i+n] - sl2Buffer[i])* x/n;                             
                           sl1Buffer[i+x] = sl1Buffer[i] + (sl1Buffer[i+n] - sl1Buffer[i])* x/n;                             
                           zliBuffer[i+x] = zliBuffer[i] + (zliBuffer[i+n] - zliBuffer[i])* x/n;                             
                        }
               }
               for (i=limit; i>=0; i--) if (slope[i]==-1) PlotPoint(i,averageDa,averageDb,average);
               return(0);
            }               
         
         if (ArrayRange(trends,0) != Bars) ArrayResize(trends,Bars);

   //
   //
   //
   //
   //

      if (slope[limit]==-1) CleanPoint(limit,averageDa,averageDb);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         average[i]   = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,Phase,i);
         averageDa[i] = EMPTY_VALUE;
         averageDb[i] = EMPTY_VALUE;
         slope[i]     = slope[i+1];
            if (average[i]>average[i+1]) slope[i] =  1;
            if (average[i]<average[i+1]) slope[i] = -1;
            if (DzStartBuyProbability1 >0) bl1Buffer[i] = dzBuyP (average, DzStartBuyProbability1,  DzLookBackBars, Bars, i, precision);
            if (DzStartBuyProbability2 >0) bl2Buffer[i] = dzBuyP (average, DzStartBuyProbability2,  DzLookBackBars, Bars, i, precision);
            if (DzStartSellProbability1>0) sl1Buffer[i] = dzSellP(average, DzStartSellProbability1, DzLookBackBars, Bars, i, precision);
            if (DzStartSellProbability2>0) sl2Buffer[i] = dzSellP(average, DzStartSellProbability2, DzLookBackBars, Bars, i, precision);
            if (ShowMiddleLine)            zliBuffer[i] = dzSellP(average, 0.5                    , DzLookBackBars, Bars, i, precision);
            if (slope[i]==-1) PlotPoint(i,averageDa,averageDb,average);
               setTrends(bl2Buffer,0,i);
               setTrends(bl1Buffer,1,i);
               setTrends(zliBuffer,2,i);
               setTrends(sl1Buffer,3,i);
               setTrends(sl2Buffer,4,i);
                  trends[r][5] = slope[i];
                  manageArrow(i);
      }
      manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void setTrends(double& array[], int forTrend, int i)
{
   int r = Bars-i-1;
      trends[r][forTrend] = trends[r-1][forTrend];
         if (average[i]>array[i]) trends[r][forTrend] =  1;
         if (average[i]<array[i]) trends[r][forTrend] = -1;
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; int forBar = Bars-whichBar-1;
      
      //
      //
      //
      //
      //
      
         static datetime time1 = 0;
         static string   mess1 = "";
            if (alertsOnBuy2CrossUp   && trends[forBar][0] ==  1 && trends[forBar-1][0] !=  1) doAlert(time1,mess1,whichBar,"crossed buy level 2 up");
            if (alertsOnBuy2CrossDown && trends[forBar][0] == -1 && trends[forBar-1][0] != -1) doAlert(time1,mess1,whichBar,"crossed buy level 2 down");
         static datetime time2 = 0;
         static string   mess2 = "";
            if (alertsOnBuy1CrossUp   && trends[forBar][1] ==  1 && trends[forBar-1][1] !=  1) doAlert(time2,mess2,whichBar,"crossed buy level 1 up");
            if (alertsOnBuy1CrossDown && trends[forBar][1] == -1 && trends[forBar-1][1] != -1) doAlert(time2,mess2,whichBar,"crossed buy level 1 down");
         static datetime time3 = 0;
         static string   mess3 = "";
            if (alertsOnMiddleCrossUp   && trends[forBar][2] ==  1 && trends[forBar-1][2] !=  1) doAlert(time3,mess3,whichBar,"crossed middle level up");
            if (alertsOnMiddleCrossDown && trends[forBar][2] == -1 && trends[forBar-1][2] != -1) doAlert(time3,mess3,whichBar,"crossed middle level down");
         static datetime time4 = 0;
         static string   mess4 = "";
            if (alertsOnSell1CrossUp   && trends[forBar][3] ==  1 && trends[forBar-1][3] !=  1) doAlert(time4,mess4,whichBar,"crossed sell level 1 up");
            if (alertsOnSell1CrossDown && trends[forBar][3] == -1 && trends[forBar-1][3] != -1) doAlert(time4,mess4,whichBar,"crossed sell level 1 down");
         static datetime time5 = 0;
         static string   mess5 = "";
            if (alertsOnSell2CrossUp   && trends[forBar][4] ==  1 && trends[forBar-1][4] !=  1) doAlert(time5,mess5,whichBar,"crossed sell level 2 up");
            if (alertsOnSell2CrossDown && trends[forBar][4] == -1 && trends[forBar-1][4] != -1) doAlert(time5,mess5,whichBar,"crossed sell level 2 down");
         static datetime time6 = 0;
         static string   mess6 = "";
            if (alertsOnSlopeUp   && trends[forBar][5] ==  1 && trends[forBar-1][5] !=  1) doAlert(time6,mess6,whichBar,"changed slope to up");
            if (alertsOnSlopeDown && trends[forBar][5] == -1 && trends[forBar-1][5] != -1) doAlert(time6,mess6,whichBar,"changed slope to down");

   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert,  int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //
       message =  timeFrameToString(Period())+" "+StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DZ jurik ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"DZ jurik"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      double dist = ArrowsGap*iATR(NULL,0,20,i);
      ObjectDelete(ArrowsIdentifier+":b2"+":"+Time[i]);         
      ObjectDelete(ArrowsIdentifier+":b1"+":"+Time[i]);         
      ObjectDelete(ArrowsIdentifier+":mi"+":"+Time[i]);         
      ObjectDelete(ArrowsIdentifier+":s1"+":"+Time[i]);         
      ObjectDelete(ArrowsIdentifier+":s2"+":"+Time[i]);         
      ObjectDelete(ArrowsIdentifier+":sl"+":"+Time[i]);         
            
      //
      //
      //
      //
      //
      int forBar = Bars-i-1;
      //if (ArrowOnBuy2CrossUp     && trends[forBar][0] ==  1 && trends[forBar-1][0] !=  1) drawArrow("b2",bl2Buffer[i],-dist,241,ArrowUpColor  ,ArrowUpWidth  ,i);
      //if (ArrowOnBuy2CrossDown   && trends[forBar][0] == -1 && trends[forBar-1][0] != -1) drawArrow("b2",bl2Buffer[i],+dist,242,ArrowDownColor,ArrowDownWidth,i);
      //if (ArrowOnBuy1CrossUp     && trends[forBar][1] ==  1 && trends[forBar-1][1] !=  1) drawArrow("b1",bl1Buffer[i],-dist,241,ArrowUpColor  ,ArrowUpWidth  ,i);
      //if (ArrowOnBuy1CrossDown   && trends[forBar][1] == -1 && trends[forBar-1][1] != -1) drawArrow("b1",bl1Buffer[i],+dist,242,ArrowDownColor,ArrowDownWidth,i);
      //if (ArrowOnMiddleCrossUp   && trends[forBar][2] ==  1 && trends[forBar-1][2] !=  1) drawArrow("mi",zliBuffer[i],-dist,241,ArrowUpColor  ,ArrowUpWidth  ,i);
      //if (ArrowOnMiddleCrossDown && trends[forBar][2] == -1 && trends[forBar-1][2] != -1) drawArrow("mi",zliBuffer[i],+dist,242,ArrowDownColor,ArrowDownWidth,i);
      //if (ArrowOnSell1CrossUp    && trends[forBar][3] ==  1 && trends[forBar-1][3] !=  1) drawArrow("s1",sl1Buffer[i],-dist,241,ArrowUpColor  ,ArrowUpWidth  ,i);
      //if (ArrowOnSell1CrossDown  && trends[forBar][3] == -1 && trends[forBar-1][3] != -1) drawArrow("s1",sl1Buffer[i],+dist,242,ArrowDownColor,ArrowDownWidth,i);
      //if (ArrowOnSell2CrossUp    && trends[forBar][4] ==  1 && trends[forBar-1][4] !=  1) drawArrow("s2",sl2Buffer[i],-dist,241,ArrowUpColor  ,ArrowUpWidth  ,i);
      //if (ArrowOnSell2CrossDown  && trends[forBar][4] == -1 && trends[forBar-1][4] != -1) drawArrow("s2",sl2Buffer[i],+dist,242,ArrowDownColor,ArrowDownWidth,i);
      //if (ArrowOnSlopeUp         && trends[forBar][5] ==  1 && trends[forBar-1][5] !=  1) drawArrow("sl",average[i]  ,-dist,241,ArrowUpColor  ,ArrowUpWidth  ,i);
      //if (ArrowOnSlopeDown       && trends[forBar][5] == -1 && trends[forBar-1][5] != -1) drawArrow("sl",average[i]  ,+dist,242,ArrowDownColor,ArrowDownWidth,i);
      
      if (ArrowOnBuy2CrossUp     && trends[forBar][0] ==  1 && trends[forBar-1][0] !=  1) drawArrow("b2",bl2Buffer[i],-dist,116,ArrowUpColor  ,ArrowUpWidth  ,i);
      if (ArrowOnBuy2CrossDown   && trends[forBar][0] == -1 && trends[forBar-1][0] != -1) drawArrow("b2",bl2Buffer[i],+dist,116,ArrowDownColor,ArrowDownWidth,i);
      if (ArrowOnBuy1CrossUp     && trends[forBar][1] ==  1 && trends[forBar-1][1] !=  1) drawArrow("b1",bl1Buffer[i],-dist,116,ArrowUpColor  ,ArrowUpWidth  ,i);
      if (ArrowOnBuy1CrossDown   && trends[forBar][1] == -1 && trends[forBar-1][1] != -1) drawArrow("b1",bl1Buffer[i],+dist,116,ArrowDownColor,ArrowDownWidth,i);
      if (ArrowOnMiddleCrossUp   && trends[forBar][2] ==  1 && trends[forBar-1][2] !=  1) drawArrow("mi",zliBuffer[i],-dist,116,ArrowUpColor  ,ArrowUpWidth  ,i);
      if (ArrowOnMiddleCrossDown && trends[forBar][2] == -1 && trends[forBar-1][2] != -1) drawArrow("mi",zliBuffer[i],+dist,116,ArrowDownColor,ArrowDownWidth,i);
      if (ArrowOnSell1CrossUp    && trends[forBar][3] ==  1 && trends[forBar-1][3] !=  1) drawArrow("s1",sl1Buffer[i],-dist,116,ArrowUpColor  ,ArrowUpWidth  ,i);
      if (ArrowOnSell1CrossDown  && trends[forBar][3] == -1 && trends[forBar-1][3] != -1) drawArrow("s1",sl1Buffer[i],+dist,116,ArrowDownColor,ArrowDownWidth,i);
      if (ArrowOnSell2CrossUp    && trends[forBar][4] ==  1 && trends[forBar-1][4] !=  1) drawArrow("s2",sl2Buffer[i],-dist,116,ArrowUpColor  ,ArrowUpWidth  ,i);
      if (ArrowOnSell2CrossDown  && trends[forBar][4] == -1 && trends[forBar-1][4] != -1) drawArrow("s2",sl2Buffer[i],+dist,116,ArrowDownColor,ArrowDownWidth,i);
      if (ArrowOnSlopeUp         && trends[forBar][5] ==  1 && trends[forBar-1][5] !=  1) drawArrow("sl",average[i]  ,-dist,116,ArrowUpColor  ,ArrowUpWidth  ,i);
      if (ArrowOnSlopeDown       && trends[forBar][5] == -1 && trends[forBar-1][5] != -1) drawArrow("sl",average[i]  ,+dist,116,ArrowDownColor,ArrowDownWidth,i);
   }
}

void drawArrow(string add, double price, double gap, int code, color theColor, int theWidth, int i)
{
   string name = ArrowsIdentifier+":"+add+":"+Time[i];
      ObjectCreate(name,OBJ_ARROW,0, Time[i],price+gap);
         ObjectSet(name,OBJPROP_ARROWCODE,code);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i)
{
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[0][k]=price; for(; k<10; k++) wrk[0][k]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax];
      double del2   = price - wrk[r-1][bsmin];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty] = MathAbs(del2); 
         wrk[r][vsum] =	wrk[r-1][vsum] + (wrk[r][volty]-wrk[r-forBar][volty])*div;
   
         //
         //
         //
         //
         //
   
         wrk[r][avolty] = wrk[r-1][avolty]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum]-wrk[r-1][avolty]);
            if (wrk[r][avolty] > 0)
               double dVolty = wrk[r][volty]/wrk[r][avolty]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax] = price; else wrk[r][bsmax] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin] = price; else wrk[r][bsmin] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0] = price + alpha*(wrk[r-1][0]-price);
         wrk[r][1] = (price - wrk[r][0])*(1-beta) + beta*wrk[r-1][1];
         wrk[r][2] = (wrk[r][0] + R*wrk[r][1]);
         wrk[r][3] = (wrk[r][2] - wrk[r-1][4])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3];
         wrk[r][4] = (wrk[r-1][4] + wrk[r][3]); 

   //
   //
   //
   //
   //

   return(wrk[r][4]);
}



//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
